/*
 * Copyright © 2008 Novell, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without
 * fee, provided that the above copyright notice appear in all copies
 * and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of
 * Novell, Inc. not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.
 * Novell, Inc. makes no representations about the suitability of this
 * software for any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
 * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
 * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: David Reveman <davidr@novell.com>
 */

#ifndef DMXSELECTION_H
#define DMXSELECTION_H

#include "dmx.h"
#include "propertyst.h"

Window
dmxBEGetSelectionAdjustedPropertyWindow (WindowPtr pWin);

void
dmxSelectionClear (ScreenPtr pScreen,
		   Window    owner,
		   Atom      xSelection);

void
dmxSelectionNotify (ScreenPtr pScreen,
		    Window    requestor,
		    Atom      xSelection,
		    Atom      xTarget,
		    Atom      xProperty,
		    Time      xTime);

Bool
dmxSelectionPropertyNotify (ScreenPtr pScreen,
			    Window    requestor,
			    int       state,
			    Atom      xProperty,
			    Time      xTime);

Bool
dmxSelectionDestroyNotify (ScreenPtr pScreen,
			   Window    requestor);

void
dmxSelectionRequest (ScreenPtr pScreen,
		     Window    owner,
		     Window    requestor,
		     Atom      xSelection,
		     Atom      xTarget,
		     Atom      xProperty,
		     Time      xTime);

void
dmxSelectionPropertyChangeCheck (WindowPtr pWin,
				 Atom      property,
				 int       nUnits);

void
dmxInitSelections (void);

void
dmxResetSelections (void);

#endif /* DMXSELECTION_H */
